/* $Id: startup.h,v 1.2 2005/06/26 01:58:58 short Exp $
 * Include file for UDP Gateway utility startup scripts s inheritance support
 * Copyright (C) 2004 Jan Kratochvil <project-udpgate@jankratochvil.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; exactly version 2 of June 1991 is required
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef _UDPGATE_STARTUP_H
#define _UDPGATE_STARTUP_H 1


#include <glib/gtypes.h>
#include <glib-object.h>


G_BEGIN_DECLS

#define UDPGATE_TYPE_STARTUP (udpgate_startup_get_type())
#define UDPGATE_STARTUP(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),UDPGATE_TYPE_STARTUP,UdpgateStartup))
#define UDPGATE_STARTUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),UDPGATE_TYPE_STARTUP,UdpgateStartupClass))
#define UDPGATE_IS_STARTUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),UDPGATE_TYPE_STARTUP))
#define UDPGATE_IS_STARTUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),UDPGATE_TYPE_STARTUP))
#define UDPGATE_STARTUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),UDPGATE_TYPE_STARTUP,UdpgateStartupClass))

typedef struct _UdpgateStartup UdpgateStartup;
typedef struct _UdpgateStartupClass UdpgateStartupClass;

struct _UdpgateStartup
{
	GObject parent_instance;
};

struct _UdpgateStartupClass
{
	GObjectClass parent_class;

	gboolean (*init)(UdpgateStartup *udpgate_startup);
	gboolean (*query)(UdpgateStartup *udpgate_startup,gboolean *is_on);
	gboolean (*on)(UdpgateStartup *udpgate_startup);
	gboolean (*off)(UdpgateStartup *udpgate_startup);
};

GType udpgate_startup_get_type(void) G_GNUC_CONST;
UdpgateStartup *udpgate_startup_new(void);
gboolean udpgate_startup_query(UdpgateStartup *udpgate_startup,gboolean *is_on);
gboolean udpgate_startup_on(UdpgateStartup *udpgate_startup);
gboolean udpgate_startup_off(UdpgateStartup *udpgate_startup);

G_END_DECLS


#endif /* _UDPGATE_STARTUP_H */
